import { Bounds } from './bounds';
export interface qTreeNCOptions {
    maxDepth?: number;
    maxChildren?: number;
}
export declare class qTreeNC<T extends object> {
    private readonly depth;
    private readonly maxChildren;
    private readonly maxDepth;
    private readonly items;
    private readonly boundsFn;
    private readonly quadCache;
    private readonly childAreas;
    private readonly children;
    private isSplit;
    constructor([x0, y0, x1, y1]: Readonly<Bounds>, options: qTreeNCOptions, boundFn: (item: T) => Bounds, quadCache: WeakMap<T, qTreeNC<T>>, depth?: number);
    clear(): void;
    insert(item: Readonly<T>): void;
    private tryChildInsert;
    remove(item: Readonly<T>): boolean;
    collectAll(result?: Readonly<T>[]): Readonly<T>[];
    collect(area: Readonly<Bounds>, result?: Readonly<T>[]): Readonly<T>[];
    all(): Generator<Readonly<T>, void, undefined>;
    search(area: Readonly<Bounds>): Generator<Readonly<T>, void, undefined>;
    size(): number;
}
//# sourceMappingURL=q-tree-no-cache.d.ts.map